Audio = Class.Create(Object, function(instance, control, defaultVolume)

--  Validate arguments
	assert(control ~= nil, "'Audio.New' requires a not null value for parameter 'control'.")
	assert(control ~= nil, "'Audio.New' requires a not null value for parameter 'defaultVolume'.")
	assert(type(defaultVolume) == "number", "'Audio.New' requires the type 'number' for parameter 'defaultVolume'.")

--  Initialization
	instance._Control        = control
	instance._DefaultVolume  = defaultVolume
	instance._PreviousVolume = instance:GetVolume()

end)

function Audio:IsMuted()
	return self:GetVolume() == 0
end

function Audio:GetVolume()
	return tonumber(GetSetting(self._Control.system, self._Control.settingId))
end

function Audio:SetVolume(volume)

	local __Volume = tonumber(volume)
	SetSetting(self._Control.system, self._Control.settingId, __Volume)
	
end

function Audio:Mute()

	local __Volume = self:GetVolume()
	
	if __Volume ~= 0 then
	
    	self:SetVolume(0)
    	self._PreviousVolume = __Volume
    	
    end
    
end

function Audio:Resume()

	local __CurrentVolume = self:GetVolume()
	
	if __CurrentVolume == 0 then
	
		local __Volume = self._PreviousVolume
	
		if __Volume == 0 then
			__Volume = self._DefaultVolume
		end
	
		self:SetVolume(__Volume)
    	self._PreviousVolume = 0
    	
    end
    
end

function Audio:ToggleMute()
	
	if self:IsMuted() then
		self:Resume()
	else
		self:Mute()
	end

end

